'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = toJS;

var _isModelTypeReference = require('./isModelTypeReference');

var _isModelTypeReference2 = _interopRequireDefault(_isModelTypeReference);

var _flowTypes = require('./flowTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function toArrayExpression(j, memberExpression, isReference) {
  var arrayExpression = j.callExpression(j.memberExpression(memberExpression, j.identifier('toArray')), []);
  if (isReference) {
    arrayExpression = j.callExpression(j.memberExpression(arrayExpression, j.identifier('map')), [j.arrowFunctionExpression([j.identifier('item')], j.callExpression(j.memberExpression(j.identifier('item'), j.identifier('toJS')), []))]);
  }
  return arrayExpression;
}

function toObjectExpression(j, memberExpression, isReference) {
  var mappedExpression = memberExpression;
  if (isReference) {
    mappedExpression = j.callExpression(j.memberExpression(memberExpression, j.identifier('map')), [j.arrowFunctionExpression([j.identifier('item')], j.callExpression(j.memberExpression(j.identifier('item'), j.identifier('toJS')), []))]);
  }
  return j.callExpression(j.memberExpression(mappedExpression, j.identifier('toObject')), []);
}

function getReturnObjectProp(j, prop) {
  var propName = prop.key.name;
  var typeAlias = prop.value;
  var isReference = (0, _isModelTypeReference2.default)(typeAlias);
  var memberExpression = j.memberExpression(j.identifier('this'), j.identifier(propName));
  var valueExpression = memberExpression;

  if (isReference) {
    valueExpression = j.callExpression(j.memberExpression(memberExpression, j.identifier('toJS')), []);
  } else {
    valueExpression = memberExpression;
  }
  var isNullable = typeAlias.type === 'NullableTypeAnnotation';
  var alias = isNullable ? typeAlias.typeAnnotation : typeAlias;
  if ((0, _flowTypes.isArray)(alias)) {
    valueExpression = toArrayExpression(j, memberExpression, isReference);
  } else if ((0, _flowTypes.isObjectMap)(alias)) {
    valueExpression = toObjectExpression(j, memberExpression, isReference);
  }
  if (valueExpression !== memberExpression && (isNullable || prop.optional)) {
    valueExpression = j.conditionalExpression(memberExpression, valueExpression, memberExpression);
  }
  return j.property('init', j.identifier(propName), valueExpression);
}

function toJS(j, className, props) {
  var toJSIdentifier = j.identifier('toJS');
  var modelTypeAnnotation = j.typeAnnotation(j.genericTypeAnnotation(j.identifier(className + 'ModelType'), null));
  var returnObjProps = props.map(function (prop) {
    return getReturnObjectProp(j, prop);
  });
  var func = j.functionExpression(null, [], j.blockStatement([j.returnStatement(j.objectExpression(returnObjProps))]));
  func.returnType = modelTypeAnnotation;
  return j.methodDefinition('method', toJSIdentifier, func, false);
}